# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rail_object_detection_msgs/Object.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Object(genpy.Message):
  _md5sum = "20713c7436f3527321b6c6724a1b80a8"
  _type = "rail_object_detection_msgs/Object"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string label            # Object label
float64 probability     # Confidence value in recognition
uint16 centroid_x       # X pixel value of the centroid of the bounding box
uint16 centroid_y       # Y pixel value of the centroid of the bounding box
uint16 left_bot_x       # X pixel value of bottom-left corner of bounding box
uint16 left_bot_y       # Y pixel value of bottom-left corner of bounding box
uint16 right_top_x      # X pixel value of top-right corner of bounding box
uint16 right_top_y      # Y pixel value of top-right corner of bounding box
"""
  __slots__ = ['label','probability','centroid_x','centroid_y','left_bot_x','left_bot_y','right_top_x','right_top_y']
  _slot_types = ['string','float64','uint16','uint16','uint16','uint16','uint16','uint16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       label,probability,centroid_x,centroid_y,left_bot_x,left_bot_y,right_top_x,right_top_y

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Object, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.label is None:
        self.label = ''
      if self.probability is None:
        self.probability = 0.
      if self.centroid_x is None:
        self.centroid_x = 0
      if self.centroid_y is None:
        self.centroid_y = 0
      if self.left_bot_x is None:
        self.left_bot_x = 0
      if self.left_bot_y is None:
        self.left_bot_y = 0
      if self.right_top_x is None:
        self.right_top_x = 0
      if self.right_top_y is None:
        self.right_top_y = 0
    else:
      self.label = ''
      self.probability = 0.
      self.centroid_x = 0
      self.centroid_y = 0
      self.left_bot_x = 0
      self.left_bot_y = 0
      self.right_top_x = 0
      self.right_top_y = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_d6H.pack(_x.probability, _x.centroid_x, _x.centroid_y, _x.left_bot_x, _x.left_bot_y, _x.right_top_x, _x.right_top_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.label = str[start:end].decode('utf-8')
      else:
        self.label = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.probability, _x.centroid_x, _x.centroid_y, _x.left_bot_x, _x.left_bot_y, _x.right_top_x, _x.right_top_y,) = _struct_d6H.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.label
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_d6H.pack(_x.probability, _x.centroid_x, _x.centroid_y, _x.left_bot_x, _x.left_bot_y, _x.right_top_x, _x.right_top_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.label = str[start:end].decode('utf-8')
      else:
        self.label = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.probability, _x.centroid_x, _x.centroid_y, _x.left_bot_x, _x.left_bot_y, _x.right_top_x, _x.right_top_y,) = _struct_d6H.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_d6H = struct.Struct("<d6H")
